/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lib.pcrypt;

import java.util.Map;
import lib.pcrypt.ast.BinExpr;
import lib.pcrypt.ast.Expr;
import lib.pcrypt.ast.IntLiteral;
import lib.pcrypt.ast.Variable;

/**
 *
 * @author Thomas
 */
public class Evaluator {
    
    public Evaluator(){
        
    }
    
    public int evaluate(BinExpr ex, Map<String, Integer> map){
        if (ex.left instanceof Variable){
            assign((Variable)ex.left, map);
        }
        
        if (ex.right instanceof Variable){
            assign((Variable)ex.right, map);
        }
        
        if (ex.op == Operator.PLUS){
            return extractVal(ex.left) + extractVal(ex.right);
        } else if (ex.op == Operator.MINUS){
            return extractVal(ex.left) - extractVal(ex.right);
        } else if (ex.op == Operator.MULT){
            return extractVal(ex.left) * extractVal(ex.right);
        } else {
            return (int)Math.pow(extractVal(ex.left), extractVal(ex.right));
        }
    }
    
    private void assign(Variable var, Map<String, Integer> map){
        Integer value = map.get(var.ident);
        if (value == null){
            throw new IllegalStateException("Unassigned variable " +  var.ident);
        }
        var.value = value;
    }
    
    private int extractVal(Expr ex){
        if (ex instanceof Variable){
            return ((Variable)ex).value;
        } else if (ex instanceof IntLiteral){
            return ((IntLiteral)ex).value;
        }
        throw new IllegalArgumentException("Illegal expression '" + ex.getClass().getSimpleName() + "' expected IntLiteral or Variable");
    }
}
