/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lib.pcrypt;

import java.util.List;
import lib.pcrypt.ast.BinExpr;
import lib.pcrypt.ast.Expr;
import lib.pcrypt.ast.IntLiteral;
import lib.pcrypt.ast.Variable;

/**
 *
 * @author Thomas
 */
public class Parser {
    
    private List<Token> tokens;
    
    private int index;
    
    public Parser(){
        
    }
    
    public Expr parse(String str){
        Tokenizer tokenizer = new Tokenizer();        
        tokens = tokenizer.tokenize(str);
        
        Expr e = parseExpr();
        while (index < tokens.size()){
            e.next = parseExpr();
        }        
        return e;
    }
    
    private Token accept(TokenType... types){
        if (index == tokens.size()){
            throw new IllegalStateException("Expected expression, got EOL");
        }
        
        for (int i = 0; i < types.length; i++){
            if (tokens.get(index).getType() == types[i]){
                return tokens.get(index);
            }
        }
        throw new IllegalArgumentException("Illegal input at character " + index + ": " + tokens.get(index).getValue());
    }
    
    private Expr parseExpr(){
        BinExpr expr = new BinExpr();
        
        if (index == tokens.size()){
            throw new IllegalStateException("Expected expression, got EOL");
        }
        expr.left = parseExpr0();
        
        Token t = accept(TokenType.PLUS, TokenType.MINUS, TokenType.MULT, TokenType.EXPONENT);
        if (t.getType() == TokenType.PLUS){
            expr.op = Operator.PLUS;
        } else if (t.getType() == TokenType.MINUS){
            expr.op = Operator.MINUS;
        } else if (t.getType() == TokenType.MULT){
            expr.op = Operator.MULT;
        } else {
            expr.op = Operator.POW;
        }
        index++;
        
        expr.right = parseExpr0();
        
        return expr;
    }
    
    private Expr parseExpr0(){
        Token t = accept(TokenType.INTEGER, TokenType.VARIABLE);        
        index++;
        
        if (t.getType() == TokenType.INTEGER){
            IntLiteral lit = new IntLiteral();
            lit.value = Integer.parseInt(t.getValue());
            
            return lit;
        } else {
            Variable var = new Variable();
            var.ident = t.getValue();
            
            return var;
        }
    }
}
